using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;

namespace TableLayoutPanel1
{
    public partial class Form1 : Form
    {
        public Form1()
        {
            InitializeComponent();

            tableLayoutPanel1.CellPaint += new TableLayoutCellPaintEventHandler(tableLayoutPanel1_CellPaint);
            foreach (Control c in tableLayoutPanel1.Controls)
            {
                c.ContextMenuStrip = contextMenuStrip1;
            }

            //ClickCxgnh؂ɒǉ
            foreach (ToolStripMenuItem submenu in cellBorderSytleToolStripMenuItem.DropDownItems)
            {
                submenu.Click += new EventHandler(cellBorderSytleValuesToolStripMenuItem_Click);
            }
            foreach (ToolStripMenuItem submenu in growStyleToolStripMenuItem.DropDownItems)
            {
                submenu.Click += new EventHandler(growStyleValuesToolStripMenuItem_Click);
            }
            foreach (ToolStripMenuItem submenu in anchorToolStripMenuItem.DropDownItems)
            {
                submenu.Click += new EventHandler(anchorStripMenuItem_Click);
            }
            foreach (ToolStripMenuItem submenu in dockToolStripMenuItem.DropDownItems)
            {
                submenu.Click += new EventHandler(dockToolStripMenuItem_Click);
            }
        }

        //tableLayoutPanel1CellPaintCxgnh
        private void tableLayoutPanel1_CellPaint(object sender,
            TableLayoutCellPaintEventArgs e)
        {
            //ɃZ̔wiFύX
            if (e.Column % 2 == 1 ^ e.Row % 2 == 1)
            {
                e.Graphics.FillRectangle(Brushes.LightSkyBlue, e.CellBounds);
            }
        }

        private void tableLayoutPanelToolStripMenuItem_DropDownOpening(object sender, EventArgs e)
        {
            //AutoScrollj[̐ݒ
            autoScrollToolStripMenuItem.Checked = tableLayoutPanel1.AutoScroll;
        }

        //j[JɃTuj[̃`FbNԂ
        private void cellBorderSytleToolStripMenuItem_DropDownOpening(object sender, EventArgs e)
        {
            string currentValue = tableLayoutPanel1.CellBorderStyle.ToString();
            foreach (ToolStripMenuItem submenu in cellBorderSytleToolStripMenuItem.DropDownItems)
            {
                submenu.Checked = (currentValue == submenu.Text);
            }
        }

        //j[NbNꂽ́Aj[TextɉăvpeBύX
        private void cellBorderSytleValuesToolStripMenuItem_Click(object sender, EventArgs e)
        {
            string enumName = ((ToolStripMenuItem) sender).Text;
            Type enumType = typeof(TableLayoutPanelCellBorderStyle);
            tableLayoutPanel1.CellBorderStyle =
                (TableLayoutPanelCellBorderStyle) Enum.Parse(enumType, enumName);
        }

        private void growStyleToolStripMenuItem_DropDownOpening(object sender, EventArgs e)
        {
            //GrowStylej[̐ݒ
            string currentValue = tableLayoutPanel1.GrowStyle.ToString();
            foreach (ToolStripMenuItem submenu in growStyleToolStripMenuItem.DropDownItems)
            {
                submenu.Checked = (currentValue == submenu.Text);
            }
        }

        //GrowStyle̕ύX
        private void growStyleValuesToolStripMenuItem_Click(object sender, EventArgs e)
        {
            string enumName = ((ToolStripMenuItem)sender).Text;
            Type enumType = typeof(TableLayoutPanelGrowStyle);
            tableLayoutPanel1.GrowStyle =
                (TableLayoutPanelGrowStyle)Enum.Parse(enumType, enumName);
        }

        //TableLayoutPanelւ̃Rg[̒ǉ
        private void addButtonToolStripMenuItem_Click(object sender, EventArgs e)
        {
            Button newButton = new Button();
            newButton.Text = "button";
            newButton.ContextMenuStrip = contextMenuStrip1;
            tableLayoutPanel1.Controls.Add(newButton);
        }

        //AutoScroll̕ύX
        private void autoScrollToolStripMenuItem_Click(object sender, EventArgs e)
        {
            tableLayoutPanel1.AutoScroll = !tableLayoutPanel1.AutoScroll;
        }

        Control currentControl = null;

        private void contextMenuStrip1_Opening(object sender, CancelEventArgs e)
        {
            currentControl = (Control)contextMenuStrip1.SourceControl;
            if (currentControl == null)
            {
                e.Cancel = true;
                return;
            }

            //Anchorj[̐ݒ
            Type enumType = typeof(AnchorStyles);
            foreach (ToolStripMenuItem submenu in anchorToolStripMenuItem.DropDownItems)
            {
                AnchorStyles enumValue = (AnchorStyles)Enum.Parse(enumType, submenu.Text);
                submenu.Checked =
                    ((enumValue & currentControl.Anchor) == enumValue);
            }

            noneToolStripMenuItem1.Checked = (currentControl.Anchor == AnchorStyles.None);

            //Dockj[̐ݒ
            Type dockEnumType = typeof(DockStyle);
            foreach (ToolStripMenuItem submenu in dockToolStripMenuItem.DropDownItems)
            {
                DockStyle enumValue = (DockStyle)Enum.Parse(dockEnumType, submenu.Text);
                submenu.Checked = (currentControl.Dock == enumValue);
            }
        }

        //Anchor̕ύX
        private void anchorStripMenuItem_Click(object sender, EventArgs e)
        {
            if (currentControl == null)
                return;
            string enumName = ((ToolStripMenuItem)sender).Text;
            if (enumName == "None")
            {
                currentControl.Anchor = AnchorStyles.None;
            }
            else
            {
                Type enumType = typeof(AnchorStyles);
                currentControl.Anchor ^=
                    (AnchorStyles)Enum.Parse(enumType, enumName);
            }
        }

        //Dock̕ύX
        private void dockToolStripMenuItem_Click(object sender, EventArgs e)
        {
            if (currentControl == null)
                return;
            string enumName = ((ToolStripMenuItem)sender).Text;
            Type enumType = typeof(DockStyle);
            currentControl.Dock =
                (DockStyle)Enum.Parse(enumType, enumName);
        }

        //ColumnSpan𑝂₷
        private void columnSpan1ToolStripMenuItem_Click(object sender, EventArgs e)
        {
            if (currentControl == null)
                return;

            int newColSpan = tableLayoutPanel1.GetColumnSpan(currentControl) + 1;
            //e[u̗̐傫Ȃ邱Ƃ
            //SetColumnSpanŃe[u̗̐傫lݒł̂ŁA`FbNȂĂȂ
            if (tableLayoutPanel1.ColumnCount >=
                tableLayoutPanel1.GetPositionFromControl(currentControl).Column + newColSpan)
            {
                tableLayoutPanel1.SetColumnSpan(currentControl, newColSpan);
            }
        }

        //RowSpan𑝂₷
        private void rowSpan1ToolStripMenuItem_Click(object sender, EventArgs e)
        {
            if (currentControl == null)
                return;

            int newRowSpan = tableLayoutPanel1.GetRowSpan(currentControl) + 1;
            tableLayoutPanel1.SetRowSpan(currentControl, newRowSpan);
        }

        //s}
        private void insertRowToolStripMenuItem_Click(object sender, EventArgs e)
        {
            if (currentControl == null)
                return;

            //}ʒu
            int insertRow = tableLayoutPanel1.GetPositionFromControl(
                currentControl).Row;
            if (insertRow < 0)
                return;

            tableLayoutPanel1.SuspendLayout();

            foreach (Control c in tableLayoutPanel1.Controls)
            {
                TableLayoutPanelCellPosition pos =
                    tableLayoutPanel1.GetPositionFromControl(c);
                tableLayoutPanel1.SetCellPosition(c, pos);
                if (tableLayoutPanel1.RowCount <= pos.Row)
                    tableLayoutPanel1.RowCount = pos.Row + 1;
                if (tableLayoutPanel1.ColumnCount <= pos.Column)
                    tableLayoutPanel1.ColumnCount = pos.Column + 1;
            }

            //𑝂₷
            tableLayoutPanel1.RowCount++;

            //Rg[ړ
            for (int y = tableLayoutPanel1.RowCount - 1; y >= insertRow; y--)
            {
                for (int x = 0; x < tableLayoutPanel1.ColumnCount; x++)
                {
                    Control c = tableLayoutPanel1.GetControlFromPosition(x, y);
                    if (c != null)
                    {
                        tableLayoutPanel1.SetCellPosition(
                            c, new TableLayoutPanelCellPosition(x, y + 1));
                    }
                }
            }

            //X^C}
            if (tableLayoutPanel1.RowStyles.Count > insertRow)
            {
                tableLayoutPanel1.RowStyles.Insert(
                    insertRow, new RowStyle(SizeType.AutoSize));
            }

            tableLayoutPanel1.ResumeLayout();
        }

        //s폜
        private void removeRowToolStripMenuItem_Click(object sender, EventArgs e)
        {
            Console.WriteLine(tableLayoutPanel1.RowCount);

            if (currentControl == null)
                return;

            //}ʒu
            int removeRow = tableLayoutPanel1.GetPositionFromControl(
                currentControl).Row;
            if (removeRow < 0)
                return;

            tableLayoutPanel1.SuspendLayout();

            foreach (Control c in tableLayoutPanel1.Controls)
            {
                TableLayoutPanelCellPosition pos =
                    tableLayoutPanel1.GetPositionFromControl(c);
                tableLayoutPanel1.SetCellPosition(c, pos);
                if (tableLayoutPanel1.RowCount <= pos.Row)
                    tableLayoutPanel1.RowCount = pos.Row + 1;
                if (tableLayoutPanel1.ColumnCount <= pos.Column)
                    tableLayoutPanel1.ColumnCount = pos.Column + 1;
            }

            //폜ɂRg[폜
            for (int x = 0; x < tableLayoutPanel1.ColumnCount; x++)
            {
                Control c = tableLayoutPanel1.GetControlFromPosition(x, removeRow);
                if (c != null)
                {
                    tableLayoutPanel1.Controls.Remove(c);
                }
            }

            //Rg[ړ
            for (int y = removeRow + 1; y < tableLayoutPanel1.RowCount; y++)
            {
                for (int x = 0; x < tableLayoutPanel1.ColumnCount; x++)
                {
                    Control c = tableLayoutPanel1.GetControlFromPosition(x, y);
                    if (c != null)
                    {
                        tableLayoutPanel1.SetCellPosition(
                            c, new TableLayoutPanelCellPosition(x, y - 1));
                    }
                }
            }

            //炷
            if (tableLayoutPanel1.RowCount > 0)
                tableLayoutPanel1.RowCount--;

            //X^C폜
            if (tableLayoutPanel1.RowStyles.Count > removeRow)
            {
                tableLayoutPanel1.RowStyles.RemoveAt(removeRow);
            }

            tableLayoutPanel1.ResumeLayout();

            Console.WriteLine(tableLayoutPanel1.RowCount);
        }
    }
}